# Welcome to Woopa() {

## Introduction

Token based authentication service for Angular2 with multiple user support. Angular2-Token works best with the [devise token auth](https://github.com/lynndylanhurley/devise_token_auth) gem for Rails.
Angular2-Token is currently in Alpha. Any contribution is much appreciated.

## Commands

You can build file with command npm run build which will run bundle and copy scripts. Notice postbundle, it’ll be run after bundle complete.

```bash
npm run build
```

Also you can bundle with defined config

```bash
rollup -c rollup.config.umd.js //umd
rollup -c rollup.config.esm.js //es2015
```

We can publish library code to npm with just command. Before do that, you need change version in `package.json` file.

```bash
npm run publish
```

## Installation

### Normal mode

```bash
npm install @woopa/angular2-token --save
```

### Development mode

```bash
cd ..
git clone [git@gitlab.woopasoft.com:222]:woopa-ui/angular2-token.git
cd %PROJECT_FOLDER%/node_modules/@woopa
rm angular2-token
ln -s ../../../woopa-ui/angular2-token/dist/ angular2-token
```

## Information

### Rollup config
`rollup.config.umd.js`

* entry: where the entry file you want to bundle.
* format: module format of your bundled file.
* moduleName: the name of the module.
* external: exclude dependency code in bundled code,which in this case, I assume user who use this library have installed 
* onwarn: Function that will intercept warning message. I ignore two unnecessary warning( THIS_IS_UNDEFINED and MISSING_GLOBAL_NAME ).
* sourceMap: Set to true so Rollup will provide sourcemap.(it’s not necessary because I don’t minify my code for simplicity.)
* plugins: plugin used in Rollup. I’ll explan next what plugin I use and why

We need to use plugins in Rollup for make magic happes.

* rollup-plugin-node-resolve
* rollup-plugin-commonjs
* rollup-plugin-angular
* rollup-plugin-typescript
* node-sass

`rollup.config.esm.js`

For ES2015 module config file,we don’t have to duplicate by hand. just import config from rollup.config.umd.js and overide some config.

}
=
